#!/bin/bash

# Enter server directory
cd papermc

# Perform initial setup
urlPrefix=https://papermc.io/api/v2/projects/paper
if [ ${MC_VERSION} = latest ]
  then
    # Get the latest MC version
    MC_VERSION=$(wget -qO - $urlPrefix | jq -r '.versions[-1]') # "-r" is needed because the output has quotes otherwise
fi
urlPrefix=${urlPrefix}/versions/${MC_VERSION}
if [ ${PAPER_BUILD} = latest ]
  then
      # Get the latest build
      PAPER_BUILD=$(wget -qO - $urlPrefix | jq '.builds[-1]')
fi

JAR_NAME=papermc-${MC_VERSION}-${PAPER_BUILD}.jar

if [ ! -e ${JAR_NAME} ]
  then
    rm -f *.jar
    wget ${urlPrefix}/builds/${PAPER_BUILD}/downloads/paper-${MC_VERSION}-${PAPER_BUILD}.jar -O ${JAR_NAME}
    if [ ! -e eula.txt ]
    then
      java -jar ${JAR_NAME}
      sed -i 's/false/true/g' eula.txt
    fi
fi
# minecraft base image laden
if [ ! -d "plugins" ]
 then
   curl -u tmueller:jtbAPAUYerYM7@h#17#*Rf0XUps6k https://tobistechblog.de/uni/initial.tar.gz --output initial.tar.gz
   tar -xvzf initial.tar.gz
fi

exec_stop () {
  echo "\n## Recieved SIGINT/SIGTERM; Shutting down container..."
  screen -wipe
  screen -r mc -p 0 -X stuff "stop^M" #sendet einen string an die session und mit ^M wird ein 'Enter' simuliert
  sleep 30 #Soll dafür sorgen dass der Container nicht sofort das script beendet währen in der session noch der befehl ausgeführt wird.
  exit 0
}

while true
	do
		screen -S mc -X select . ; SCRUN=$? #Queryabfrage um rauszufindne ob screensession noch aktiv ist. Return: bool
		if [ ${SCRUN} = 0 ]
			then # Server läuft, zeige letzte zeilen vom log an...
				tail /papermc/logs/latest.log
				trap exec_stop TERM INT # SIGTERM ^C etc abfangen und funktion für gracefull shutdown aufrufen
				sleep 10 # CPU Zeit sparen da eine downtime von max 10s + Startzeit des javapplets vertretbar ist kann bei bedarf beliebig erhöht werden.
			else # Server läuft nicht, abgestürzt, gestoppt über minecraft /stop 
				screen -dmS mc java -server -Xms${MC_RAM} -Xmx${MC_RAM} ${JAVA_OPTS} -jar ${JAR_NAME} nogui #Startupbefehl inkl. ENVs vom Dockerfile
				screen -wipe # sollte der server mal abstürzen oder sont irgednwie ein fehler auftreten wird damit zombiesessions entfernt.
		fi
	done
